Index: issm/trunk/src/c/classes/Node.cpp
===================================================================
--- issm/trunk/src/c/classes/Node.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Node.cpp	(revision 26744)
@@ -20,6 +20,4 @@
 	this->approximation  = 0;
 	this->gsize          = -1;
-	this->fsize          = -1;
-	this->ssize          = -1;
 	this->clone          = false;
 	this->active         = true;
@@ -68,11 +66,9 @@
 		this->svalues        = xNew<IssmDouble>(this->gsize);
 		this->gdoflist       = xNew<int>(this->gsize);
-		this->gdoflist_local = xNewZeroInit<int>(this->gsize);
-		this->fsize          = -1;
-		this->ssize          = -1;
-		this->fdoflist       = NULL;
-		this->sdoflist       = NULL;
-		this->fdoflist_local = NULL;
-		this->sdoflist_local = NULL;
+		this->gdoflist_local = xNew<int>(this->gsize);
+		this->fdoflist       = xNew<int>(this->gsize);
+		this->sdoflist       = xNew<int>(this->gsize);
+		this->fdoflist_local = xNew<int>(this->gsize);
+		this->sdoflist_local = xNew<int>(this->gsize);
 	}
 	else{
@@ -82,6 +78,4 @@
 		this->gdoflist       = NULL;
 		this->gdoflist_local = NULL;
-		this->fsize          = -1;
-		this->ssize          = -1;
 		this->fdoflist       = NULL;
 		this->sdoflist       = NULL;
@@ -96,4 +90,9 @@
 		this->svalues[i]  = 0.;
 		this->gdoflist[i] = -1;
+		this->fdoflist[i] = -1;
+		this->sdoflist[i] = -1;
+		this->gdoflist_local[i] = -1;
+		this->fdoflist_local[i] = -1;
+		this->sdoflist_local[i] = -1;
 	}
 
@@ -210,6 +209,4 @@
 	output->indexingupdate = this->indexingupdate;
 	output->gsize  = this->gsize;
-	output->fsize  = this->fsize;
-	output->ssize  = this->ssize;
 	output->clone  = this->clone;
 	output->active = this->active;
@@ -222,12 +219,8 @@
 		output->gdoflist=xNew<int>(output->gsize);
 		output->gdoflist_local=xNew<int>(output->gsize);
-	}
-	if(output->fsize>0){
-		output->fdoflist=xNew<int>(output->fsize);
-		output->fdoflist_local=xNew<int>(output->fsize);
-	}
-	if(output->ssize>0){
-		output->sdoflist=xNew<int>(output->ssize);
-		output->sdoflist_local=xNew<int>(output->ssize);
+		output->fdoflist=xNew<int>(output->gsize);
+		output->fdoflist_local=xNew<int>(output->gsize);
+		output->sdoflist=xNew<int>(output->gsize);
+		output->sdoflist_local=xNew<int>(output->gsize);
 	}
 
@@ -239,12 +232,8 @@
 		memcpy(output->gdoflist,this->gdoflist,output->gsize*sizeof(int));
 		memcpy(output->gdoflist_local,this->gdoflist_local,output->gsize*sizeof(int));
-	}
-	if(output->fsize>0){
-		memcpy(output->fdoflist,this->fdoflist,output->fsize*sizeof(int));
-		memcpy(output->fdoflist_local,this->fdoflist_local,output->fsize*sizeof(int));
-	}
-	if(output->ssize>0){
-		memcpy(output->sdoflist,this->sdoflist,output->ssize*sizeof(int));
-		memcpy(output->sdoflist_local,this->sdoflist_local,output->ssize*sizeof(int));
+		memcpy(output->fdoflist,this->fdoflist,output->gsize*sizeof(int));
+		memcpy(output->fdoflist_local,this->fdoflist_local,output->gsize*sizeof(int));
+		memcpy(output->sdoflist,this->sdoflist,output->gsize*sizeof(int));
+		memcpy(output->sdoflist_local,this->sdoflist_local,output->gsize*sizeof(int));
 	}
 
@@ -267,6 +256,4 @@
 
 	marshallhandle->call(this->gsize);
-	marshallhandle->call(this->fsize);
-	marshallhandle->call(this->ssize);
 	marshallhandle->call(this->clone);
 	marshallhandle->call(this->active);
@@ -277,9 +264,9 @@
 	marshallhandle->call(this->doftype,gsize);
 	marshallhandle->call(this->gdoflist,gsize);
-	marshallhandle->call(this->fdoflist,fsize);
-	marshallhandle->call(this->sdoflist,ssize);
+	marshallhandle->call(this->fdoflist,gsize);
+	marshallhandle->call(this->sdoflist,gsize);
 	marshallhandle->call(this->gdoflist_local,gsize);
-	marshallhandle->call(this->fdoflist_local,fsize);
-	marshallhandle->call(this->sdoflist_local,ssize);
+	marshallhandle->call(this->fdoflist_local,gsize);
+	marshallhandle->call(this->sdoflist_local,gsize);
 } /*}}}*/
 
@@ -295,6 +282,4 @@
 	_printf_("   indexingupdate: " << indexingupdate << "\n");
 	_printf_("   gsize:  " << gsize << "\n");
-	_printf_("   fsize:  " << fsize << "\n");
-	_printf_("   ssize:  " << ssize << "\n");
 	_printf_("   clone:  " << clone << "\n");
 	_printf_("   active: " << active << "\n");
@@ -306,5 +291,5 @@
 	for(i=0;i<gsize;i++) _printf_((s_set[i]?1:0)<< " ");
 	_printf_("]\n");
-	_printf_("   svalues (" << this->ssize << "): |");
+	_printf_("   svalues: |");
 	for(i=0;i<this->gsize;i++){
 		if(this->s_set[i])_printf_(" " << svalues[i] << " |");
@@ -327,16 +312,16 @@
 	_printf_("\n");
 
-	_printf_("   f_doflist (" << this->fsize << "): |");
-	for(i=0;i<this->fsize;i++) _printf_(" " << fdoflist[i] << " |");
+	_printf_("   f_doflist (" << this->gsize << "): |");
+	for(i=0;i<this->gsize;i++) _printf_(" " << fdoflist[i] << " |");
 	_printf_("\n");
-	_printf_("   f_doflist_local (" << this->fsize << "): |");
-	for(i=0;i<this->fsize;i++) _printf_(" " << fdoflist_local[i] << " |");
+	_printf_("   f_doflist_local (" << this->gsize << "): |");
+	for(i=0;i<this->gsize;i++) _printf_(" " << fdoflist_local[i] << " |");
 	_printf_("\n");
 
-	_printf_("   s_doflist (" << this->ssize << "): |");
-	for(i=0;i<this->ssize;i++) _printf_(" " << sdoflist[i] << " |");
+	_printf_("   s_doflist (" << this->gsize << "): |");
+	for(i=0;i<this->gsize;i++) _printf_(" " << sdoflist[i] << " |");
 	_printf_("\n");
-	_printf_("   s_doflist_local (" << this->ssize << "): |");
-	for(i=0;i<this->ssize;i++) _printf_(" " << sdoflist_local[i] << " |");
+	_printf_("   s_doflist_local (" << this->gsize << "): |");
+	for(i=0;i<this->gsize;i++) _printf_(" " << sdoflist_local[i] << " |");
 	_printf_("\n");
 
@@ -354,6 +339,4 @@
 	_printf_("   indexingupdate: " << indexingupdate << "\n");
 	_printf_("   gsize:  " << gsize << "\n");
-	_printf_("   fsize:  " << fsize << "\n");
-	_printf_("   ssize:  " << ssize << "\n");
 	_printf_("   clone:  " << clone << "\n");
 	_printf_("   active: " << active << "\n");
@@ -386,9 +369,9 @@
 	}
 	else if(setenum==FsetEnum){
-		_assert_(dofindex>=0 && dofindex<fsize);
+		_assert_(dofindex>=0 && dofindex<gsize);
 		return fdoflist[dofindex];
 	}
 	else if(setenum==SsetEnum){
-		_assert_(dofindex>=0 && dofindex<ssize);
+		_assert_(dofindex>=0 && dofindex<gsize);
 		return sdoflist[dofindex];
 	}
@@ -397,226 +380,48 @@
 } /*}}}*/
 void Node::GetDofList(int* outdoflist,int approximation_enum,int setenum){/*{{{*/
+	_assert_(!this->indexingupdate);
 	int i;
-	int count=0;
-	int count2=0;
+
+	int* doflistpointer = NULL;
+	if(setenum==GsetEnum) doflistpointer = gdoflist;
+	else if(setenum==FsetEnum)for(i=0;i<this->gsize;i++) doflistpointer = fdoflist;
+	else if(setenum==SsetEnum)for(i=0;i<this->gsize;i++) doflistpointer = sdoflist;
+	else _error_("not supported");
+
+	if(approximation_enum==NoneApproximationEnum){
+		for(i=0;i<this->gsize;i++) outdoflist[i]=doflistpointer[i];
+	}
+	else{
+		if(doftype){
+			int count = 0;
+			for(i=0;i<this->gsize;i++){
+				if(doftype[i]==approximation_enum) outdoflist[count++]=doflistpointer[i];
+			}
+		}
+		else for(i=0;i<this->gsize;i++) outdoflist[i]=doflistpointer[i];
+	}
+}/*}}}*/
+void Node::GetDofListLocal(int* outdoflist,int approximation_enum,int setenum){/*{{{*/
 
 	_assert_(!this->indexingupdate);
+	int i;
+
+	int* doflistpointer = NULL;
+	if(setenum==GsetEnum) doflistpointer = gdoflist_local;
+	else if(setenum==FsetEnum)for(i=0;i<this->gsize;i++) doflistpointer = fdoflist_local;
+	else if(setenum==SsetEnum)for(i=0;i<this->gsize;i++) doflistpointer = sdoflist_local;
+	else _error_("not supported");
 
 	if(approximation_enum==NoneApproximationEnum){
-		if(setenum==GsetEnum)for(i=0;i<this->gsize;i++) outdoflist[i]=gdoflist[i];
-		if(setenum==FsetEnum)for(i=0;i<this->fsize;i++) outdoflist[i]=fdoflist[i];
-		if(setenum==SsetEnum)for(i=0;i<this->ssize;i++) outdoflist[i]=sdoflist[i];
+		for(i=0;i<this->gsize;i++) outdoflist[i]=doflistpointer[i];
 	}
 	else{
-
-		if(setenum==GsetEnum){
-			if(doftype){
-				count=0;
-				for(i=0;i<this->gsize;i++){
-					if(doftype[i]==approximation_enum){
-						outdoflist[count]=gdoflist[i];
-						count++;
-					}
-				}
-				_assert_(count); //at least one dof should be the approximation requested
-			}
-			else for(i=0;i<this->gsize;i++) outdoflist[i]=gdoflist[i];
-		}
-		else if(setenum==FsetEnum){
-			if(doftype){
-				count=0;
-				count2=0;
-				for(i=0;i<this->gsize;i++){
-					if(f_set[i]){
-						if(doftype[i]==approximation_enum){
-							outdoflist[count]=fdoflist[count2];
-							count++;
-						}
-						count2++;
-					}
-				}
-			}
-			else for(i=0;i<this->fsize;i++) outdoflist[i]=fdoflist[i];
-		}
-		else if(setenum==SsetEnum){
-			if(doftype){
-				count=0;
-				count2=0;
-				for(i=0;i<this->gsize;i++){
-					if(s_set[i]){
-						if(doftype[i]==approximation_enum){
-							outdoflist[count]=sdoflist[count2];
-							count++;
-						}
-						count2++;
-					}
-				}
-			}
-			else for(i=0;i<this->ssize;i++) outdoflist[i]=sdoflist[i];
-		}
-		else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
-	}
-}
-/*}}}*/
-void Node::GetDofListLocal(int* outdoflist,int approximation_enum,int setenum){/*{{{*/
-	int i;
-	int count=0;
-	int count2=0;
-
-	_assert_(!this->indexingupdate);
-
-	if(approximation_enum==NoneApproximationEnum){
-		if(setenum==GsetEnum)for(i=0;i<this->gsize;i++) outdoflist[i]=gdoflist_local[i];
-		if(setenum==FsetEnum)for(i=0;i<this->fsize;i++) outdoflist[i]=fdoflist_local[i];
-		if(setenum==SsetEnum)for(i=0;i<this->ssize;i++) outdoflist[i]=sdoflist_local[i];
-	}
-	else{
-
-		if(setenum==GsetEnum){
-			if(doftype){
-				count=0;
-				for(i=0;i<this->gsize;i++){
-					if(doftype[i]==approximation_enum){
-						outdoflist[count]=gdoflist_local[i];
-						count++;
-					}
-				}
-				_assert_(count); //at least one dof should be the approximation requested
-			}
-			else for(i=0;i<this->gsize;i++) outdoflist[i]=gdoflist_local[i];
-		}
-		else if(setenum==FsetEnum){
-			if(doftype){
-				count=0;
-				count2=0;
-				for(i=0;i<this->gsize;i++){
-					if(f_set[i]){
-						if(doftype[i]==approximation_enum){
-							outdoflist[count]=fdoflist_local[count2];
-							count++;
-						}
-						count2++;
-					}
-				}
-			}
-			else for(i=0;i<this->fsize;i++) outdoflist[i]=fdoflist_local[i];
-		}
-		else if(setenum==SsetEnum){
-			if(doftype){
-				count=0;
-				count2=0;
-				for(i=0;i<this->gsize;i++){
-					if(s_set[i]){
-						if(doftype[i]==approximation_enum){
-							outdoflist[count]=sdoflist_local[count2];
-							count++;
-						}
-						count2++;
-					}
-				}
-			}
-			else for(i=0;i<this->ssize;i++) outdoflist[i]=sdoflist_local[i];
-		}
-		else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
-	}
-}
-/*}}}*/
-void Node::GetLocalDofList(int* outdoflist,int approximation_enum,int setenum){/*{{{*/
-	int i;
-	int count=0;
-	int count2=0;
-
-	_assert_(!this->indexingupdate);
-
-	if(approximation_enum==NoneApproximationEnum){
-		if(setenum==GsetEnum)for(i=0;i<this->gsize;i++) outdoflist[i]=i;
-		else if(setenum==FsetEnum){
-			count=0;
+		if(doftype){
+			int count =0;
 			for(i=0;i<this->gsize;i++){
-				if(f_set[i]){
-					outdoflist[count]=i;
-					count++;
-				}
-			}
-		}
-		else if(setenum==SsetEnum){
-			count=0;
-			for(i=0;i<this->gsize;i++){
-				if(s_set[i]){
-					outdoflist[count]=i;
-					count++;
-				}
-			}
-		}
-		else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
-	}
-	else{
-
-		if(setenum==GsetEnum){
-			if(doftype){
-				count=0;
-				for(i=0;i<this->gsize;i++){
-					if(doftype[i]==approximation_enum){
-						outdoflist[count]=count;
-						count++;
-					}
-				}
-				_assert_(count);
-			}
-			else for(i=0;i<this->gsize;i++) outdoflist[i]=i;
-		}
-		else if(setenum==FsetEnum){
-
-			if(doftype){
-				count=0;
-				count2=0;
-				for(i=0;i<this->gsize;i++){
-					if(doftype[i]==approximation_enum){
-						if(f_set[i]){
-							outdoflist[count]=count2;
-							count++;
-						}
-						count2++;
-					}
-				}
-				_assert_(count2);
-			}
-			else{
-
-				count=0;
-				for(i=0;i<this->gsize;i++){
-					if(f_set[i]){
-						outdoflist[count]=i;
-						count++;
-					}
-				}
-			}
-		}
-		else if(setenum==SsetEnum){
-			if(doftype){
-				count=0;
-				count2=0;
-				for(i=0;i<this->gsize;i++){
-					if(doftype[i]==approximation_enum){
-						if(s_set[i]){
-							outdoflist[count]=count2;
-							count++;
-						}
-						count2++;
-					}
-				}
-				_assert_(count2);
-			}
-			else{
-				count=0;
-				for(i=0;i<this->gsize;i++){
-					if(s_set[i]){
-						outdoflist[count]=i;
-						count++;
-					}
-				}
-			}
-		}
-		else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
+				if(doftype[i]==approximation_enum) outdoflist[count++]=doflistpointer[i];
+			}
+		}
+		else for(i=0;i<this->gsize;i++) outdoflist[i]=doflistpointer[i];
 	}
 }
@@ -660,29 +465,10 @@
 void Node::CreateNodalConstraints(Vector<IssmDouble>* ys){/*{{{*/
 
-	int i;
-	IssmDouble* values=NULL;
-	int count;
-
-	/*Recover values for s set and plug them in constraints vector: */
-	if(this->ssize){
-		values=xNew<IssmDouble>(this->ssize);
-		count=0;
-		for(i=0;i<this->gsize;i++){
-			if(this->s_set[i]){
-				values[count]=this->svalues[i];
-				_assert_(!xIsNan<IssmDouble>(values[count]));
-				count++;
-			}
-		}
-
+	if(this->SSize()){
 		/*Add values into constraint vector: */
-		ys->SetValues(this->ssize,this->sdoflist,values,INS_VAL);
-	}
-
-	/*Free ressources:*/
-	xDelete<IssmDouble>(values);
-
-}
-/*}}}*/
+		ys->SetValues(this->gsize,this->sdoflist,this->svalues,INS_VAL);
+	}
+
+}/*}}}*/
 void Node::Deactivate(void){/*{{{*/
 
@@ -705,9 +491,9 @@
 	_assert_(this->active);
 
-	if(this->f_set[dof] == 0){
+	if(!this->f_set[dof]){
 		if(this->freeze) _error_("Cannot change dof of frozen node");
 		this->indexingupdate = true;
-		this->f_set[dof]=1; 
-		this->s_set[dof]=0;
+		this->f_set[dof]=true; 
+		this->s_set[dof]=false;
 	}
 }
@@ -719,9 +505,9 @@
 	_assert_(dof<this->gsize);
 
-	if(this->f_set[dof] == 1){
+	if(this->f_set[dof]){
 		//if(this->freeze) _error_("Cannot change dof of frozen node");
 		this->indexingupdate = true;
-		this->f_set[dof]=0; //n splits into f (for which we solve) and s (single point constraints)
-		this->s_set[dof]=1;
+		this->f_set[dof]=false; //n splits into f (for which we solve) and s (single point constraints)
+		this->s_set[dof]=true;
 	}
 }
@@ -755,6 +541,6 @@
 	if(approximation_enum==NoneApproximationEnum){
 		if      (setenum==GsetEnum) numdofs=this->gsize;
-		else if (setenum==FsetEnum) numdofs=this->fsize;
-		else if (setenum==SsetEnum) numdofs=this->ssize;
+		else if (setenum==FsetEnum) numdofs=this->FSize();
+		else if (setenum==SsetEnum) numdofs=this->SSize();
 		else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
 	}
@@ -776,5 +562,5 @@
 				}
 			}
-			else numdofs=this->fsize;
+			else numdofs=this->FSize();
 		}
 		else if (setenum==SsetEnum){
@@ -785,5 +571,5 @@
 				}
 			}
-			else numdofs=this->ssize;
+			else numdofs=this->SSize();
 		}
 		else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
@@ -800,21 +586,12 @@
 /*}}}*/
 bool Node::IsActive(void){/*{{{*/
-
 	return active;
-
-}
-/*}}}*/
+}/*}}}*/
 int  Node::IsClone(){/*{{{*/
-
 	return clone;
-
-}
-/*}}}*/
+}/*}}}*/
 void Node::ReindexingDone(void){/*{{{*/
-
 	this->indexingupdate = false;
-
-}
-/*}}}*/
+}/*}}}*/
 void Node::RelaxConstraint(int dof){/*{{{*/
 
@@ -837,7 +614,11 @@
 	if(this->IsClone()) return;
 
-	if(this->fsize){
-		int*        indices = xNew<int>(this->fsize);
-		IssmDouble* values  = xNew<IssmDouble>(this->fsize);
+	/*Get F size and S size*/
+	int fsize = this->FSize();
+	int ssize = this->SSize();
+
+	if(fsize){
+		int*        indices = xNew<int>(fsize);
+		IssmDouble* values  = xNew<IssmDouble>(fsize);
 
 		int count = 0;
@@ -845,19 +626,19 @@
 			if(this->f_set[i]){
 				_assert_(local_uf);
-				_assert_(this->fdoflist[count]==indices_uf[this->fdoflist_local[count]]);
-
-				values[count] =local_uf[this->fdoflist_local[count]];
+				_assert_(this->fdoflist[i]==indices_uf[this->fdoflist_local[i]]);
+
+				values[count] =local_uf[this->fdoflist_local[i]];
 				indices[count]=this->gdoflist[i];
 				count++;
 			}
 		}
-		ug->SetValues(this->fsize,indices,values,INS_VAL);
+		ug->SetValues(fsize,indices,values,INS_VAL);
 
 		xDelete<IssmDouble>(values);
 		xDelete<int>(indices);
 	}
-	if(this->ssize){
-		int*        indices = xNew<int>(this->ssize);
-		IssmDouble* values  = xNew<IssmDouble>(this->ssize);
+	if(ssize){
+		int*        indices = xNew<int>(ssize);
+		IssmDouble* values  = xNew<IssmDouble>(ssize);
 
 		int count = 0;
@@ -865,13 +646,13 @@
 			if(this->s_set[i]){
 				_assert_(local_ys);
-				_assert_(this->sdoflist[count]==indices_ys[this->sdoflist_local[count]]);
-
-				values[count] =local_ys[this->sdoflist_local[count]];
+				_assert_(this->sdoflist[i]==indices_ys[this->sdoflist_local[i]]);
+
+				values[count] =local_ys[this->sdoflist_local[i]];
 				indices[count]=this->gdoflist[i];
 				count++;
 			}
 		}
-		ug->SetValues(this->ssize,indices,values,INS_VAL);
-		
+		ug->SetValues(ssize,indices,values,INS_VAL);
+
 		xDelete<IssmDouble>(values);
 		xDelete<int>(indices);
@@ -881,11 +662,13 @@
 void Node::VecReduce(Vector<IssmDouble>* uf, IssmDouble* local_ug,int* indices_ug){/*{{{*/
 
-
 	/*Only perform operation if not clone*/
 	if(this->IsClone()) return;
 
-	if(this->fsize){
-		int*        indices = xNew<int>(this->fsize);
-		IssmDouble* values  = xNew<IssmDouble>(this->fsize);
+	/*Get F size*/
+	int fsize = this->FSize();
+
+	if(fsize){
+		int*        indices = xNew<int>(fsize);
+		IssmDouble* values  = xNew<IssmDouble>(fsize);
 
 		int count = 0;
@@ -894,11 +677,13 @@
 				_assert_(local_ug);
 				_assert_(this->gdoflist[i]==indices_ug[this->gdoflist_local[i]]);
+				_assert_(this->fdoflist[i]>=0);
 
 				values[count] =local_ug[this->gdoflist_local[i]];
-				indices[count]=this->fdoflist[count];
+				indices[count]=this->fdoflist[i];
 				count++;
 			}
 		}
-		uf->SetValues(this->fsize,indices,values,INS_VAL);
+		_assert_(count==fsize);
+		uf->SetValues(fsize,indices,values,INS_VAL);
 
 		xDelete<IssmDouble>(values);
@@ -909,42 +694,4 @@
 
 /* indexing routines:*/
-void Node::AllocateDofLists(int setenum){/*{{{*/
-
-	/*Initialize: */
-	int size=0;
-
-	if(setenum==FsetEnum){
-		for(int i=0;i<this->gsize;i++) if(f_set[i])size++;
-		this->fsize=size;
-		xDelete<int>(this->fdoflist);
-		xDelete<int>(this->fdoflist_local);
-
-		if(this->fsize){
-			this->fdoflist=xNew<int>(size);
-			this->fdoflist_local=xNew<int>(size);
-		}
-		else{
-			this->fdoflist=NULL;
-			this->fdoflist_local=NULL;
-		}
-	}
-	else if(setenum==SsetEnum){
-		for(int i=0;i<this->gsize;i++) if(s_set[i])size++;
-		this->ssize=size;
-		xDelete<int>(this->sdoflist);
-		xDelete<int>(this->sdoflist_local);
-
-		if(this->ssize){
-			this->sdoflist=xNew<int>(size);
-			this->sdoflist_local=xNew<int>(size);
-		}
-		else{
-			this->sdoflist=NULL;
-			this->sdoflist_local=NULL;
-		}
-	}
-	/*TODO, we should never be here for GSET! add an assert and track down whether this happens*/
-}
-/*}}}*/
 void Node::DistributeLocalDofs(int* pdofcount,int setenum){/*{{{*/
 
@@ -955,16 +702,17 @@
 	if(setenum==GsetEnum){
 		_assert_(this->gsize==0 || this->gdoflist_local);
-		for(int i=0;i<this->gsize;i++) gdoflist_local[i]=dofcount+i;
-		dofcount+=this->gsize;
+		for(int i=0;i<this->gsize;i++) gdoflist_local[i]=dofcount++;
 	}
 	else if(setenum==FsetEnum){
-		_assert_(this->fsize==0 || this->fdoflist_local);
-		for(int i=0;i<this->fsize;i++) fdoflist_local[i]=dofcount+i;
-		dofcount+=this->fsize;
+		for(int i=0;i<this->gsize;i++){
+			if(this->f_set[i]) fdoflist_local[i]=dofcount++;
+			else               fdoflist_local[i]=-1;
+		}
 	}
 	else if(setenum==SsetEnum){
-		_assert_(this->ssize==0 || this->sdoflist_local);
-		for(int i=0;i<this->ssize;i++) sdoflist_local[i]=dofcount+i;
-		dofcount+=this->ssize;
+		for(int i=0;i<this->gsize;i++){
+			if(this->s_set[i]) sdoflist_local[i]=dofcount++;
+			else               sdoflist_local[i]=-1;
+		}
 	}
 	else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
@@ -972,6 +720,5 @@
 	/*Assign output pointers: */
 	*pdofcount=dofcount;
-}
-/*}}}*/
+}/*}}}*/
 void Node::DistributeGlobalDofsMasters(int dofcount,int setenum){/*{{{*/
 
@@ -985,10 +732,14 @@
 	}
 	else if(setenum==FsetEnum){
-		_assert_(this->fsize==0 || this->fdoflist);
-		for(int i=0;i<this->fsize;i++) this->fdoflist[i]=this->fdoflist_local[i]+dofcount;
+		for(int i=0;i<this->gsize;i++){
+			if(this->f_set[i]) fdoflist[i]=this->fdoflist_local[i]+dofcount;
+			else               fdoflist[i]=-1;
+		}
 	}
 	else if(setenum==SsetEnum){
-		_assert_(this->ssize==0 || this->sdoflist);
-		for(int i=0;i<this->ssize;i++) this->sdoflist[i]=this->sdoflist_local[i]+dofcount;
+		for(int i=0;i<this->gsize;i++){
+			if(this->s_set[i]) sdoflist[i]=this->sdoflist_local[i]+dofcount;
+			else               sdoflist[i]=-1;
+		}
 	}
 	else _error_("set of enum type " << EnumToStringx(setenum) << " not supported yet!");
@@ -1005,8 +756,8 @@
 			break;
 		case FsetEnum:
-			for(int j=0;j<this->fsize;j++) truedofs[j]=fdoflist[j];
+			for(int j=0;j<this->gsize;j++) truedofs[j]=fdoflist[j];
 			break;
 		case SsetEnum:
-			for(int j=0;j<this->ssize;j++) truedofs[j]=sdoflist[j];
+			for(int j=0;j<this->gsize;j++) truedofs[j]=sdoflist[j];
 			break;
 		default:
@@ -1027,8 +778,8 @@
 			break;
 		case FsetEnum:
-			for(int j=0;j<this->fsize;j++) fdoflist[j]=alltruedofs[j];
+			for(int j=0;j<this->gsize;j++) fdoflist[j]=alltruedofs[j];
 			break;
 		case SsetEnum:
-			for(int j=0;j<this->ssize;j++) sdoflist[j]=alltruedofs[j];
+			for(int j=0;j<this->gsize;j++) sdoflist[j]=alltruedofs[j];
 			break;
 		default:
@@ -1037,10 +788,27 @@
 }
 /*}}}*/
+int  Node::FSize(void){/*{{{*/
+
+	_assert_(this!=NULL && this->gdoflist);
+
+	int fsize = 0;
+	for(int i=0;i<this->gsize;i++) if(this->f_set[i]) fsize++;
+	return fsize;
+}
+/*}}}*/
+int  Node::SSize(void){/*{{{*/
+
+	_assert_(this!=NULL && this->s_set);
+
+	int ssize = 0;
+	for(int i=0;i<this->gsize;i++) if(this->s_set[i]) ssize++;
+	return ssize;
+}
+/*}}}*/
 
 /*Methods inherent to Node: */
 int* GetGlobalDofList(Node** nodes,int numnodes,int setenum,int approximation){/*{{{*/
 
-	int  i,numdof,count;
-	int* ndof_list=NULL;
+	/*output*/
 	int *doflist = NULL;
 
@@ -1048,10 +816,10 @@
 
 		/*Allocate:*/
-		ndof_list=xNew<int>(numnodes);
+		int* ndof_list=xNew<int>(numnodes);
 
 		/*First, figure out size of doflist: */
-		numdof=0;
-		for(i=0;i<numnodes;i++){
-			ndof_list[i]=nodes[i]->GetNumberOfDofs(approximation,setenum);
+		int numdof=0;
+		for(int i=0;i<numnodes;i++){
+			ndof_list[i]=nodes[i]->GetNumberOfDofs(approximation,GsetEnum);
 			numdof+=ndof_list[i];
 		}
@@ -1062,6 +830,6 @@
 
 			/*Populate: */
-			count=0;
-			for(i=0;i<numnodes;i++){
+			int count=0;
+			for(int i=0;i<numnodes;i++){
 				nodes[i]->GetDofList(&doflist[count],approximation,setenum);
 				count+=ndof_list[i];
@@ -1069,65 +837,9 @@
 		}
 		else doflist=NULL;
-	}
-	/*Free ressources:*/
-	xDelete<int>(ndof_list);
-
-	return doflist;
-}
-/*}}}*/
-int* GetLocalDofList(Node** nodes,int numnodes,int setenum,int approximation){ /*{{{*/
-
-	int  i,j,count,numdof,numgdof;
-	int* ndof_list=NULL;
-	int* ngdof_list_cumulative=NULL;
-	int *doflist = NULL;
-
-	if(numnodes){
-		/*allocate: */
-		ndof_list=xNew<int>(numnodes);
-		ngdof_list_cumulative=xNew<int>(numnodes);
-
-		/*Get number of dofs per node, and total for this given set*/
-		numdof=0;
-		numgdof=0;
-		for(i=0;i<numnodes;i++){
-
-			/*Cumulative list= number of dofs before node i*/
-			ngdof_list_cumulative[i]=numgdof;
-
-			/*Number of dofs for node i for given set and for the g set*/
-			ndof_list[i]=nodes[i]->GetNumberOfDofs(approximation,setenum);
-			numgdof    +=nodes[i]->GetNumberOfDofs(approximation,GsetEnum);
-			numdof     +=ndof_list[i];
-		}
-
-		if(numdof){
-			/*Allocate: */
-			doflist=xNew<int>(numdof);
-
-			/*Populate: */
-			count=0;
-			for(i=0;i<numnodes;i++){
-				nodes[i]->GetLocalDofList(&doflist[count],approximation,setenum);
-				count+=ndof_list[i];
-			}
-
-			/*We now have something like: [0 1 0 2 1 2]. Offset by gsize, to get something like: [0 1 2 4 6 7]:*/
-			count=0;
-			for(i=0;i<numnodes;i++){
-				for(j=0;j<ndof_list[i];j++){
-					doflist[count+j]+=ngdof_list_cumulative[i];
-				}
-				count+=ndof_list[i];
-			}
-		}
-		else doflist=NULL;
-	}
-
-	/*Free ressources:*/
-	xDelete<int>(ndof_list);
-	xDelete<int>(ngdof_list_cumulative);
-
-	/*CLean-up and return*/
+
+		/*Free ressources:*/
+		xDelete<int>(ndof_list);
+	}
+
 	return doflist;
 }
Index: issm/trunk/src/c/classes/Node.h
===================================================================
--- issm/trunk/src/c/classes/Node.h	(revision 25994)
+++ issm/trunk/src/c/classes/Node.h	(revision 26744)
@@ -43,6 +43,4 @@
 		/*sizes: */
 		int gsize;   //number of dofs for a node
-		int fsize;   //number of dofs solver for
-		int ssize;   //number of constrained dofs
 
 		/*Activation*/
@@ -56,5 +54,5 @@
 
 		/*types of dofs: */
-		int        *doftype;   //approximation type of the dofs (used only for coupling), size g_size
+		int  *doftype;   //approximation type of the dofs (used only for coupling), size g_size
 
 		/*list of degrees of freedom: */
@@ -80,5 +78,4 @@
 
 		/*Node numerical routines*/
-		void  AllocateDofLists(int setenum);
 		void  Activate(void);
 		void  ApplyConstraint(int dof,IssmDouble value);
@@ -94,11 +91,8 @@
 		void  GetDofList(int* poutdoflist,int approximation_enum,int setenum);
 		void  GetDofListLocal(int* poutdoflist,int approximation_enum,int setenum);
-		void  GetLocalDofList(int* poutdoflist,int approximation_enum,int setenum);
 		int   GetNumberOfDofs(int approximation_enum,int setenum);
 		void  HardDeactivate(void);
 		bool  IsActive(void);
 		int   IsClone();
-		int   IsFloating();
-		int   IsGrounded();
 		int   Lid(void); 
 		void  DistributeGlobalDofsMasters(int dofcount,int setenum);
@@ -114,9 +108,10 @@
 		void  VecReduce(Vector<IssmDouble>* uf, IssmDouble* local_ug,int* indices_ug);
 		void  SetApproximation(int in_approximation);
+		int   SSize();
+		int   FSize();
 };
 
 /*Methods inherent to Node: */
 int* GetGlobalDofList(Node** nodes,int numnodes,int setenum,int approximation);
-int* GetLocalDofList(Node** nodes,int numnodes,int setenum,int approximation);
 int  GetNumberOfDofs(Node** nodes,int numnodes,int setenum,int approximation);
 
Index: issm/trunk/src/c/classes/Nodes.cpp
===================================================================
--- issm/trunk/src/c/classes/Nodes.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Nodes.cpp	(revision 26744)
@@ -147,10 +147,4 @@
 	int num_procs = IssmComm::GetSize();
 
-	/*First, allocate dof lists based on fset and sset*/
-	for(Object* & object : this->objects){
-      Node* node = xDynamicCast<Node*>(object);
-		node->AllocateDofLists(setenum);
-	}
-
 	/*Now, Build local dofs for masters first*/
 	int  dofcount=0;
@@ -187,5 +181,5 @@
 	 * object that is not a clone, tell them to show their dofs, so that later on, they can get picked
 	 * up by their clones: */
-	int  maxdofspernode = this->MaxNumDofs(setenum);
+	int  maxdofspernode = this->MaxNumDofs(GsetEnum);
 	int* truedofs       = xNewZeroInit<int>(this->Size()*maxdofspernode); //only one alloc
 	for(int rank=0;rank<num_procs;rank++){
Index: issm/trunk/src/c/classes/Params/TransientArrayParam.cpp
===================================================================
--- issm/trunk/src/c/classes/Params/TransientArrayParam.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Params/TransientArrayParam.cpp	(revision 26744)
@@ -20,5 +20,5 @@
 }
 /*}}}*/
-TransientArrayParam::TransientArrayParam(int in_enum_type,IssmDouble* in_values,IssmDouble* in_time,bool interpolation_on,int in_N,int in_M){/*{{{*/
+TransientArrayParam::TransientArrayParam(int in_enum_type,IssmDouble* in_values,IssmDouble* in_time,bool interpolation_on,bool cycle_in,int in_N,int in_M){/*{{{*/
 
 	_assert_(in_values && in_time);
@@ -28,10 +28,11 @@
 	this->N=in_N; //Number of timesteps
 	this->interpolation=interpolation_on;
+	this->cycle=cycle_in;
 
 	this->values=xNew<IssmDouble>(M*N);
-	xMemCpy<IssmDouble>(values,in_values,M*N);
+	xMemCpy<IssmDouble>(this->values,in_values,M*N);
 
 	this->timesteps=xNew<IssmDouble>(N);
-	xMemCpy<IssmDouble>(timesteps,in_time,N);
+	xMemCpy<IssmDouble>(this->timesteps,in_time,N);
 }
 /*}}}*/
@@ -44,5 +45,5 @@
 Param* TransientArrayParam::copy() {/*{{{*/
 
-	return new TransientArrayParam(this->enum_type,this->values,this->timesteps,this->interpolation,this->M,this->N);
+	return new TransientArrayParam(this->enum_type,this->values,this->timesteps,this->interpolation,this->cycle,this->M,this->N);
 
 }
@@ -80,4 +81,5 @@
 	marshallhandle->call(this->enum_type);
 	marshallhandle->call(this->interpolation);
+	marshallhandle->call(this->cycle);
 	marshallhandle->call(this->M);
 	marshallhandle->call(this->N);
@@ -102,4 +104,6 @@
 	bool       found;
 	_assert_(row>=0 && row<this->M); 
+
+	if(this->cycle) _error_("not implemented yet");
 
 	/*Ok, we have the time and row, go through the timesteps, and figure out which interval we 
@@ -129,5 +133,5 @@
 					IssmDouble deltat = this->timesteps[i+1]-this->timesteps[i];
 					IssmDouble alpha  = (time-this->timesteps[i])/deltat;
-					if(interpolation==true) output=(1.0-alpha)*this->values[row*this->N+i] + alpha*this->values[row*this->N+i+1];
+					if(this->interpolation==true) output=(1.0-alpha)*this->values[row*this->N+i] + alpha*this->values[row*this->N+i+1];
 					else output=this->values[row*this->N+i];
 					found=true;
Index: issm/trunk/src/c/classes/Params/TransientArrayParam.h
===================================================================
--- issm/trunk/src/c/classes/Params/TransientArrayParam.h	(revision 25994)
+++ issm/trunk/src/c/classes/Params/TransientArrayParam.h	(revision 26744)
@@ -25,4 +25,5 @@
 		int         M;
 		bool        interpolation;
+		bool        cycle;
 		IssmDouble *values;
 		IssmDouble *timesteps;
@@ -31,5 +32,5 @@
 		/*TransientArrayParam constructors, destructors: {{{*/
 		TransientArrayParam();
-		TransientArrayParam(int in_enum_type,IssmDouble* in_values,IssmDouble* in_time,bool interpolation_on,int in_N,int in_M);
+		TransientArrayParam(int in_enum_type,IssmDouble* in_values,IssmDouble* in_time,bool interpolation_on,bool cycle_in,int in_N,int in_M);
 		~TransientArrayParam();
 		/*}}}*/
